/*
	Created by Jesse R. Warden a.k.a. "JesterXL"
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	http://www.universalmind.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/
*/

package com.jxl.cairngorm
{
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.adobe.cairngorm.commands.ICommand;
	
	import com.jxl.cairngorm.JXLResponder;
	import com.jxl.cairngorm.JXLEvent;
	import com.jxl.cairngorm.JXLCallback;
	
	import mx.rpc.events.ResultEvent;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.IResponder;
	
	public class JXLCommand implements ICommand, IResponder
	{
		
		protected var responder:JXLResponder;
		
		public function JXLCommand()
		{
		}
		
		public function execute(event:CairngormEvent):void
		{
			var jxlEvent:JXLEvent = event as JXLEvent;
			responder = jxlEvent.responder;
		}
		
		public function result(callback:Object):void
		{
			if(responder != null) responder.result(callback as JXLCallback);
		}
		
		public function fault(fault:Object):void
		{
			if(responder != null) responder.fault(fault as FaultEvent);
		}
		
		// utility method for calling Delegates
		public function getResponder(p_result:Function=null, p_fault:Function=null):JXLResponder
		{
			var handler:JXLResponder;
			if(p_result != null || p_fault != null)
			{
				handler = new JXLResponder(p_result, p_fault);
			}
			else
			{
				handler = responder;
			}
			return handler;
		}
	}
}