/*
	Created by Jesse R. Warden a.k.a. "JesterXL"
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	http://www.universalmind.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/
*/
package com.jxl.downloads.commands
{
	import mx.rpc.Responder;
	
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.adobe.cairngorm.control.CairngormEventDispatcher;
	
	import com.jxl.downloads.events.DownloadsEvent;
	import com.jxl.downloads.callbacks.DownloadsCallback;
	
	import com.jxl.downloads.model.ModelLocator;
	import com.jxl.downloads.business.DownloadsDelegate;
	import mx.collections.ArrayCollection;
	import com.adobe.cairngorm.commands.ICommand;
	import com.jxl.cairngorm.JXLCommand;
	
	public class DownloadsCommand extends JXLCommand implements ICommand
	{
		public override function execute(p_event:CairngormEvent):void
		{
			DebugWindow.debugHeader();
			DebugWindow.debug("DownloadsCommand::execute, p_event.type: " + p_event.type);
			
			super.execute(p_event);
			
			switch(p_event.type)
			{
				case DownloadsEvent.GET_DOWNLOADS:
					getDownloads(DownloadsEvent(p_event));
					break;
			}
		}
		
		protected function getDownloads(p_event:DownloadsEvent):void
		{
			getDelegate(onGetDownloads_Result, onGetDownloads_Fault).getDownloads();
		}
		
		protected function onGetDownloads_Result(p_result:ResultEvent):void
		{
			var ac:ArrayCollection = p_result.result as ArrayCollection;
			ModelLocator.getInstance().downloads_ac = ac;
			
			var callback:DownloadsCallback = new DownloadsCallback ( ac.length );
			result(callback);
		}
		
		protected function onGetDownloads_Fault(p_event:FaultEvent):void
		{
			// alert some error
			fault(p_event);
		}
		
		private function getDelegate(p_result:Function=null, p_fault:Function=null):DownloadsDelegate
		{
			return new DownloadsDelegate(getResponder(p_result, p_fault));
		}
		
	}
}