/*
	Created by Jesse R. Warden a.k.a. "JesterXL"
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	http://www.universalmind.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/
*/
package com.jxl.downloads.commands
{
	import mx.rpc.Responder;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	
	import com.adobe.cairngorm.control.CairngormEvent;
	import com.adobe.cairngorm.control.CairngormEventDispatcher;
	
	import com.adobe.cairngorm.commands.ICommand;
	import com.jxl.downloads.events.LoginEvent;
	import com.jxl.downloads.callbacks.LoginCallback;
	import flash.net.Responder;
	import com.jxl.downloads.business.LoginDelegate;
	import com.jxl.cairngorm.JXLCommand;
	
	public class LoginCommand extends JXLCommand implements ICommand
	{
		public override function execute(p_event:CairngormEvent):void
		{
			DebugWindow.debugHeader();
			DebugWindow.debug("LoginCommand::execute, p_event.type: " + p_event.type);
			
			super.execute(p_event);
			
			var le:LoginEvent = p_event as LoginEvent;
			login(le.username, le.password);
		}
		
		protected function login(p_username:String, p_password:String):void
		{
			getDelegate(onLogin_Result, onLogin_Fault).login(p_username, p_password);
		}
		
		protected function onLogin_Result(p_result:ResultEvent):void
		{
			DebugWindow.debugHeader();
			DebugWindow.debug("LoginCommand::onLogin_Result");
			
			var event:LoginCallback = new LoginCallback(LoginCallback.LOGIN_SUCCESS);
			result(event);
		}
		
		protected function onLogin_Fault(p_event:FaultEvent):void
		{
			// alert some error
			fault(p_event);
		}
		
		private function getDelegate(p_result:Function=null, p_fault:Function=null):LoginDelegate
		{
			return new LoginDelegate(getResponder(p_result, p_fault));
		}
		
	}
}