/*
	Created by Jesse R. Warden a.k.a. "JesterXL"
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	http://www.universalmind.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/
*/
package com.jxl.downloads.factories
{
	import com.jxl.downloads.vo.DownloadVO;
	import mx.collections.ArrayCollection;
	import com.jxl.downloads.vo.AMFPHPTransferObject;
	
	public class DownloadFactory
	{
		
		public static function getDownloads(p_amfphpTO:AMFPHPTransferObject):ArrayCollection
		{
			//DebugWindow.debugHeader();
			//DebugWindow.debug("DownloadFactory::getDownloads");
			//DebugWindow.debug("p_amfphpTO.totalCount: " + p_amfphpTO.totalCount);
				
			var i:int = p_amfphpTO.totalCount;
			var a:Array = [];
			while(i--)
			{
				var o:Array = p_amfphpTO.initialData[i] as Array;
				var obj:Object = arrayToObject(p_amfphpTO.columnNames, o);
				var vo:DownloadVO = getDownload(obj);
				//DebugWindow.debug("vo: " + vo);
				a[i] = vo;
			}
			var ac:ArrayCollection = new ArrayCollection(a);
			return ac;
		}
		
		public static function arrayToObject(p_fieldsArray:Array, p_array:Object):Object
		{
			var i:int = p_fieldsArray.length;
			var obj:Object = {};	
			while(i--)
			{
				var name:String = p_fieldsArray[i] as String;
				var o:* = p_array[i];
				obj[name] = o;
			}
			return obj;
		}
		
		public static function getDownload(p_obj:Object):DownloadVO
		{
			//DebugWindow.debugHeader();
			//DebugWindow.debug("DownloadFactory::getDownload");
			//DebugWindow.debugProps(p_obj);
			
			// FIXME: Until value objects are working,
			// I'll need to convert the field names
			// from MySQL
			var vo:DownloadVO = new DownloadVO(p_obj.id,
												p_obj.category,
												p_obj.section,
												p_obj.title,
												p_obj.description,
												p_obj.file_title,
												p_obj.file_url,
												p_obj.mxp_title,
												p_obj.mxp_url,
												p_obj.zip_title,
												p_obj.zip_url,
												p_obj.blog_title,
												p_obj.blog_url,
												p_obj.embed_html);
			return vo;
		}
		
	}
}