﻿/*
	Created by Jesse R. Warden a.k.a. "JesterXL"
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	http://www.universalmind.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/
*/
package com.jxl.downloads.views
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import mx.core.SoundAsset;
	import flash.media.SoundChannel;
	
	
	[Embed(source="../../../../assets/flash/BackgroundPanel.swf", symbol="com.jxl.downloads.views.BackgroundPanelSymbol")]
	public class BackgroundPanelSymbol extends MovieClip
	{
		
		public static const DONE_HIDDEN:String 				= "com.jxl.downloads.views.BackgroundPanelSymbol.doneHidden";
		public static const DONE_INTRO:String 				= "com.jxl.downloads.views.BackgroundPanelSymbol.doneIntro";
		public static const DONE_SPIN:String 				= "com.jxl.downloads.views.BackgroundPanelSymbol.doneSpin";
		public static const DONE_MAIN:String 				= "com.jxl.downloads.views.BackgroundPanelSymbol.doneMain";
		public static const DONE_INTRO_PRELOADING:String 	= "com.jxl.downloads.views.BackgroundPanelSymbol.doneIntroPreload";
		public static const DONE_SPIN_PRELOADING:String 	= "com.jxl.downloads.views.BackgroundPanelSymbol.doneSpinPreload";
		
		[Embed(source="../../../../assets/audio/fon.mp3")]
		protected var __fon_sound_asset:Class;
		protected var __fon_sound:SoundAsset;
		protected var __fon_sound_channel:SoundChannel;
		
		public function BackgroundPanelSymbol()
		{
			super();
			gotoAndStop("hidden");
		}
		
		public function hidden():void
		{
			removeAllEvents();
			if(__fon_sound_channel != null) __fon_sound_channel.stop();
			gotoAndStop("hidden");
			dispatchEvent(new Event(DONE_HIDDEN));
		}
		
		public function showMain():void
		{
			removeAllEvents();
			gotoAndStop("face");
			dispatchEvent(new Event(DONE_MAIN));
		}
		
		public function showIntro():void
		{
			removeAllEvents();
			gotoAndPlay("intro");
			addEventListener(Event.ENTER_FRAME, onIntroPlaying);
		}
		
		public function preloadSpin():void
		{
			//DebugWindow.debugHeader();
			//DebugWindow.debug("BackgroundPanelSymbol::preloadSpin");
			removeAllEvents();
			gotoAndPlay("spin_preload");
			addEventListener(Event.ENTER_FRAME, onSpinPreloadPlaying);
		}
		
		public function preloadIntro():void
		{
			removeAllEvents();
			gotoAndPlay("intro_preload");
			addEventListener(Event.ENTER_FRAME, onIntroPreloadPlaying);
		}
		
		protected function onIntroPlaying(p_event:Event):void
		{
			//DebugWindow.debugHeader();
			//DebugWindow.debug("BackgroundPanelSymbol::onIntroPlaying");
			if(currentLabel == "fon_sound_start")
			{
				
				if(__fon_sound == null)
				{
					__fon_sound = new __fon_sound_asset() as SoundAsset;
				}
				
				if(__fon_sound_channel != null)
				{
					__fon_sound_channel.stop();
				}
				__fon_sound_channel = __fon_sound.play(0, 999);
				
			}
			if(currentLabel == "face")
			{
				stop();
				removeAllEvents();
				dispatchEvent(new Event(DONE_INTRO));
			}
		}
		
		public function showSpin():void
		{
			removeAllEvents();
			gotoAndPlay("spin");
			addEventListener(Event.ENTER_FRAME, onSpinPlaying);
		}
		
		protected function onSpinPlaying(p_event:Event):void
		{
			if(currentLabel == "spin_done")
			{
				removeAllEvents();
				gotoAndStop("face");
				dispatchEvent(new Event(DONE_SPIN));
			}
		}
		
		protected function onSpinPreloadPlaying(p_event:Event):void
		{
			//DebugWindow.debugHeader();
			//DebugWindow.debug("BackgroundPanelSymbol::onSpinPreloadPlaying");
			//DebugWindow.debug("currentFrame: " + currentFrame);
			if(currentLabel == "spin_preload_done")
			{
				//DebugWindow.debug("done preloading!");
				removeAllEvents();
				gotoAndStop("face");
				dispatchEvent(new Event(DONE_SPIN_PRELOADING));
			}
		}
		
		protected function onIntroPreloadPlaying(p_event:Event):void
		{
			if(currentLabel == "intro_preload_done")
			{
				removeAllEvents();
				stop();
				dispatchEvent(new Event(DONE_INTRO_PRELOADING));
			}
		}
		
		protected function removeAllEvents():void
		{
			removeEventListener(Event.ENTER_FRAME, onIntroPlaying);
			removeEventListener(Event.ENTER_FRAME, onSpinPlaying);
			removeEventListener(Event.ENTER_FRAME, onSpinPreloadPlaying);
			removeEventListener(Event.ENTER_FRAME, onIntroPreloadPlaying);
		}
		
	}
}