/*
	Created by Jesse R. Warden a.k.a. "JesterXL"
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	http://www.universalmind.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/
*/
package com.jxl.downloads.views
{
	
	import mx.preloaders.DownloadProgressBar;
	
	import com.jxl.downloads.views.JXLDownloadsPreloaderSymbol;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.ProgressEvent;
	import mx.events.FlexEvent;

	public class JXLDownloadsPreloader extends DownloadProgressBar
	{
		
		protected var __preloader:JXLDownloadsPreloaderSymbol;
		
		public function JXLDownloadsPreloader()
		{
			super();
			
			__preloader = new JXLDownloadsPreloaderSymbol();
			__preloader.visible = false;
			addChild(__preloader);
		}
		
		override public function set preloader(p_preloader:Sprite):void 
        {                   
            p_preloader.addEventListener( ProgressEvent.PROGRESS , onSWFDownloadProgress );    
            p_preloader.addEventListener( Event.COMPLETE , onSWFDownloadComplete );
            p_preloader.addEventListener( FlexEvent.INIT_PROGRESS , onFlexInitProgress );
            p_preloader.addEventListener( FlexEvent.INIT_COMPLETE , onFlexInitComplete );
            
            centerPreloader();
        }
        
        protected function centerPreloader():void
		{
			x = (stageWidth / 2) - (__preloader.width / 2);
			y = (stageHeight / 2) - (__preloader.height / 2);
			if(__preloader.visible == false) __preloader.visible = true;
		}
		
    
        protected function onSWFDownloadProgress( event:ProgressEvent ):void
        {
        	var t:Number = event.bytesTotal;
        	var l:Number = event.bytesLoaded;
        	var p:Number = Math.round( (l / t) * 100);
        	__preloader.setAmount(p);
        	__preloader.setAmountText(String(p) + "%");
        }
    
        protected function onSWFDownloadComplete( event:Event ):void
        {
       		__preloader.setAmount(100);
        	__preloader.setAmountText("100%");
        }
    
        protected function onFlexInitProgress( event:FlexEvent ):void
        {
        	__preloader.setAmount(100);
        	__preloader.setAmountText("100%");
        }
    
        protected function onFlexInitComplete( event:FlexEvent ):void 
        {
        	__preloader.setAmount(100);
        	__preloader.setAmountText("100%");
        	__preloader.addEventListener(JXLDownloadsPreloaderSymbol.DONE_FADING, onDoneFading);
        	__preloader.transitionOut();
        }
        
        protected function onDoneFading(p_event:Event):void
        {
        	__preloader.removeEventListener(JXLDownloadsPreloaderSymbol.DONE_FADING, onDoneFading);
        	dispatchEvent( new Event( Event.COMPLETE ) );
        }
		
	}
}

