﻿/*
	Created by Jesse R. Warden a.k.a. "JesterXL"
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	http://www.universalmind.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/
*/
package com.jxl.downloads.views
{
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import mx.core.SoundAsset;
	import flash.media.SoundChannel;
	
	import flash.media.SoundTransform;
	
	[Embed(source="../../../../assets/flash/PanelButton.swf", symbol="com.jxl.downloads.views.PanelButtonSymbol")]
	public class PanelButtonSymbol extends MovieClip
	{
		
		public static const DONE_HIDDEN:String 				= "com.jxl.downloads.views.PanelButtonSymbol.doneHidden";
		public static const DONE_APPEARING:String 			= "com.jxl.downloads.views.PanelButtonSymbol.doneAppearing";
		public static const DONE_DISAPPEARING:String 		= "com.jxl.downloads.views.PanelButtonSymbol.doneDisappearing";
		
		
		
		protected var __text:String = "";
		
		public var __label_mc:MovieClip;
		
		[Embed(source="../../../../assets/audio/button_roll_over.mp3")]
		protected var __rollOver_sound_asset:Class;
		protected var __rollOver_sound:SoundAsset;
		protected var __rollOver_sound_channel:SoundChannel;
		
		[Embed(source="../../../../assets/audio/button_hit.mp3")]
		protected var __hit_sound_asset:Class;
		protected var __hit_sound:SoundAsset;
		protected var __hit_sound_channel:SoundChannel;
		
		
		public function PanelButtonSymbol()
		{
			super();
			gotoAndStop(1);
			
			__rollOver_sound = new __rollOver_sound_asset() as SoundAsset;
			__rollOver_sound_channel = __rollOver_sound.play();
			var transform:SoundTransform = __rollOver_sound_channel.soundTransform;
			transform.volume = .5;
			__rollOver_sound_channel.soundTransform = transform;
			__rollOver_sound_channel.stop();
			
			__hit_sound = new __hit_sound_asset() as SoundAsset;
			__hit_sound_channel = __hit_sound.play();
			var hitTransform:SoundTransform = __hit_sound_channel.soundTransform;
			hitTransform.volume = .5;
			__hit_sound_channel.soundTransform = hitTransform;
			__hit_sound_channel.stop();
			
		}
		
		public function setText(p_val:String):void
		{
			__text = p_val;
			if(__label_mc != null)
			{
				__label_mc.__label_txt.text = p_val.toUpperCase();
			}
		}
		
		public function hidden():void
		{
			removeAllEvents();
			gotoAndStop(1);
			dispatchEvent(new Event(DONE_HIDDEN));
		}
		
		public function showMain():void
		{
			gotoAndStop("up");
			removeAllEvents();
			addMouseEvents();
		}
		
		public function appear():void
		{
			removeAllEvents();
			gotoAndPlay("appear");
			addEventListener(Event.ENTER_FRAME, onAppearPlaying);
		}
		
		protected function onAppearPlaying(p_event:Event):void
		{
			if(currentFrame == 7)
			{
				// __label_mc will exist at frame 6, but his label inside exists at frame 7
				setText(__text);
			}
			if(currentLabel == "up")
			{
				gotoAndStop("up");
				removeAllEvents();
				addMouseEvents();
				dispatchEvent(new Event(DONE_APPEARING));
			}
		}
		
		public function disappear():void
		{
			removeAllEvents();
			removeMouseEvents();
			gotoAndPlay("disappear_start");
			addEventListener(Event.ENTER_FRAME, onDisappearPlaying);
		}
		
		protected function onDisappearPlaying(p_event:Event):void
		{
			if(currentLabel == "disappear_end")
			{
				gotoAndStop("disappear_end");
				removeAllEvents();
				dispatchEvent(new Event(DONE_DISAPPEARING));
			}
		}
		
		public function onRollOver(p_event:MouseEvent):void
		{
			removeAllEvents();
			__rollOver_sound_channel.stop();
			__rollOver_sound.play();
			gotoAndPlay("over_start");
			addEventListener(Event.ENTER_FRAME, onRollOverPlaying);
		}
		
		protected function onRollOverPlaying(p_event:Event):void
		{
			if(currentLabel == "over_end")
			{
				gotoAndStop("over_end");
				removeAllEvents();
			}
		}
		
		public function onRollOut(p_event:MouseEvent):void
		{
			removeAllEvents();
			gotoAndPlay("out_start");
			addEventListener(Event.ENTER_FRAME, onRollOutPlaying);
		}
		
		protected function onRollOutPlaying(p_event:Event):void
		{
			if(currentLabel == "out_end")
			{
				gotoAndStop("out_end");
				removeAllEvents();
			}
		}
		
		protected function onClick(p_event:MouseEvent):void
		{
			__hit_sound_channel.stop();
			__hit_sound.play();
		}
		
		protected function addMouseEvents():void
		{
			if(hasEventListener(MouseEvent.ROLL_OVER) == false)
				addEventListener(MouseEvent.ROLL_OVER, onRollOver);
			if(hasEventListener(MouseEvent.ROLL_OUT) == false)
				addEventListener(MouseEvent.ROLL_OUT, onRollOut);
			if(hasEventListener(MouseEvent.CLICK) == false)
				addEventListener(MouseEvent.CLICK, onClick);
		}
		
		protected function removeMouseEvents():void
		{
			removeEventListener(MouseEvent.ROLL_OVER, onRollOver);
			removeEventListener(MouseEvent.ROLL_OUT, onRollOut);
			removeEventListener(MouseEvent.CLICK, onClick);
		}
		
		protected function removeAllEvents():void
		{
			removeEventListener(Event.ENTER_FRAME, onAppearPlaying);
			removeEventListener(Event.ENTER_FRAME, onDisappearPlaying);
		}
		
	}
}