/*
	Created by Jesse R. Warden a.k.a. "JesterXL"
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	http://www.universalmind.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/
*/
package com.jxl.downloads.views
{
	import mx.core.UIComponent;
	import mx.states.State;
	
	import com.jxl.downloads.views.SkiesSymbol;
	import mx.events.FlexEvent;
	import flash.events.Event;
	
	public class Skies extends UIComponent
	{
		
		public static const STATE_HIDDEN:String 			= "hiddenState";
		public static const STATE_MAIN:String 				= "mainState";
		public static const STATE_FADE_IN:String 			= "fadeInState";
		public static const STATE_FADE_OUT:String 			= "fadeOutState";
		
		protected var __hidden_state:State;
		protected var __main_state:State;
		protected var __fadeIn_state:State;
		protected var __fadeOut_state:State;
		
		protected var __skySymbol:SkiesSymbol;
		
		public function Skies()
		{
			super();
			
			__hidden_state = new State();
			__hidden_state.name = STATE_HIDDEN;
			__hidden_state.addEventListener(FlexEvent.ENTER_STATE, onHiddenStateEnter);
			states.push(__hidden_state);
			
			__main_state = new State();
			__main_state.name = STATE_MAIN;
			__main_state.addEventListener(FlexEvent.ENTER_STATE, onMainStateEnter);
			states.push(__main_state);
			
			__fadeIn_state = new State();
			__fadeIn_state.name = STATE_FADE_IN;
			__fadeIn_state.addEventListener(FlexEvent.ENTER_STATE, onFadeInStateEnter);
			states.push(__fadeIn_state);
			
			__fadeOut_state = new State();
			__fadeOut_state.name = STATE_FADE_OUT;
			__fadeOut_state.addEventListener(FlexEvent.ENTER_STATE, onFadeOutStateEnter);
			states.push(__fadeOut_state);
			
			currentState = STATE_HIDDEN;
			
		}
		
		protected override function createChildren():void
		{
			super.createChildren();
			
			if(__skySymbol == null)
			{
				__skySymbol = new SkiesSymbol();
				addChild(__skySymbol);
				
				__skySymbol.addEventListener(SkiesSymbol.DONE_FADE_OUT, onDoneTransitioning);
				__skySymbol.addEventListener(SkiesSymbol.DONE_FADE_IN, onDoneTransitioning);
			}
		}
		
		protected function onHiddenStateEnter(p_event:FlexEvent):void
		{
			__skySymbol.hidden();
		}
		
		protected function onMainStateEnter(p_event:FlexEvent):void
		{
			__skySymbol.showMain();
		}
		
		protected function onFadeInStateEnter(p_event:FlexEvent):void
		{
			__skySymbol.fadeIn();
		}
		
		protected function onFadeOutStateEnter(p_event:FlexEvent):void
		{
			__skySymbol.fadeOut();
		}
		
		protected function onDoneTransitioning(p_event:Event):void
		{
			switch(p_event.type)
			{
				case SkiesSymbol.DONE_FADE_IN:
					currentState = STATE_MAIN;
					break;
				
				case SkiesSymbol.DONE_FADE_OUT:
					currentState = STATE_HIDDEN;
					break;
			}
		}
	}
}