/*

	Transition code ganked from Senocular
	http://www.senocular.com/flash/source.php?id=0.189

	Created by Jesse R. Warden a.k.a. "JesterXL"
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	http://www.universalmind.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/
*/
package com.jxl.effects
{
	import mx.effects.effectClasses.TweenEffectInstance;
	import mx.events.ChildExistenceChangedEvent;
	import flash.display.BitmapData;
	import mx.core.UIComponent;
	import flash.display.Bitmap;
	import flash.geom.Matrix;
	import flash.display.DisplayObject;
	import mx.graphics.RoundedRectangle;
	import mx.core.mx_internal;
	import flash.display.IBitmapDrawable;
	import flash.geom.Rectangle;
	
	public class PixelateInstance extends TweenEffectInstance
	{
		
		public var pixelSizeFrom:Number = 1;
		public var pixelSizeTo:Number = 80;
		
		public var targetArea:RoundedRectangle;
		
		private var overlay:UIComponent;
		private var original:Bitmap;
		
		public function PixelateInstance(target:Object)
		{
			super(target);
			
			var bitmapData:BitmapData = new BitmapData( target.width, 
														target.height, 
														true );
			original = new Bitmap(bitmapData);
			original.bitmapData.draw(target as IBitmapDrawable);
		}
		
		public override function play():void
		{
			super.play();
			
			var targetWidth:Number = target.width;
			var targetHeight:Number = target.height;
			
			target.addEventListener(ChildExistenceChangedEvent.OVERLAY_CREATED,
									overlayCreatedHandler);
									
			target.mx_internal::addOverlay(0x000000, targetArea);
			
            // tween is created in overlayCreatedHandler
		}
		
		private function overlayCreatedHandler(event:ChildExistenceChangedEvent):void
		{
			target.removeEventListener(ChildExistenceChangedEvent.OVERLAY_CREATED,
									   overlayCreatedHandler);
			
			event.stopImmediatePropagation();
									   
			overlay = UIComponent(event.relatedObject);
			overlay.width = target.width;
			overlay.height = target.height;
			
			tween = createTween(this, pixelSizeFrom, pixelSizeTo, duration);
	
			// Set the animation to the initial value before the screen refreshes.
			mx_internal::applyTweenStartValues();
		}
		
		public override function onTweenUpdate(val:Object):void
		{
			var wrapper:UIComponent = new UIComponent();
			overlay.addChild(wrapper);
			var pixelSize:Number = val as Number;
			var tar:UIComponent = target as UIComponent;
			var bitmapData:BitmapData = new BitmapData( tar.width / pixelSize, 
														tar.height / pixelSize, 
														true );
			var bitmap:Bitmap = new Bitmap(bitmapData);
			var scaleMatrix:Matrix = new Matrix();
			scaleMatrix.scale( 1 / pixelSize, 1 / pixelSize);
			bitmap.bitmapData.draw(original, scaleMatrix);
			bitmap.width = tar.width;
			bitmap.height = tar.height;
			wrapper.addChild(bitmap);
		}

		public override function onTweenEnd(value:Object):void
		{
			super.onTweenEnd(value);
		
			target.mx_internal::removeOverlay();
		}
	}
}
